package lifr.util.tests;

import java.util.Iterator;

import lifr.logic.firstorder.KnowledgeBase;
import lifr.logic.firstorder.LogicFactory;
import lifr.logic.firstorder.Predicate;
import lifr.reasoner.ProofNotFoundException;
import lifr.reasoner.Reasoner;
import lifr.reasoner.krhyper.KrHyper;
import lifr.util.KRSSFuzzyParser;


public class Test {
	
	protected static final int reasonerTimeout = 6000;
    protected static int unsolved_memory = 0;
    protected static int unsolved_timeout = 0;
    protected static final int mintermweight = 2;
    public static int refuted = 0;
    
    public static String problem(){
    	String s = "";
    	
    	return s;
    }
    
    public static void makeMatch(){
    	KnowledgeBase kb = new KnowledgeBase();
    	Reasoner reasoner = new KrHyper();
    	LogicFactory.initialize();
    	String problem = 
//    		"(IMPLIES E (OR A B))" + "\n" + 
//        	"(IMPLIES Z (OR A C D))" + "\n" + 
    		"(IMPLIES B A)" + "\n" +
    		"(IMPLIES C M)" + "\n" +
        	"(DISJOINT M A)" + "\n" + 
        	"(INSTANCE a B >= 1.0)" + "\n" + 
        	"(INSTANCE a C >= 1.0)" + "\n" + 
//        	"(INSTANCE a M >= 1.0)" + "\n";
//        	"(INSTANCE a M < 0.1)" + "\n";
//    		"(IMPLIES A B)" + "\n" +
//    		"(IMPLIES B (and C D))" + "\n" +
//    		"(IMPLIES E D)" + "\n" +
//    		"(INSTANCE a A >= 0.6)" + "\n" +
//    		"(INSTANCE a E < 0.8)" + "\n";
//    		"(INSTANCE a E > 0.8)" + "\n";
        	"";
    	KRSSFuzzyParser parser = new KRSSFuzzyParser(problem);
    	KnowledgeBase matchKb = parser.getKB();
//    	System.out.println(matchKb.toString());
    	kb.mergeKnowledgeBase(matchKb);
        reasoner.setKnowledgeBase(kb);
        
        @SuppressWarnings("unused")
        String s = kb.toString();
        
        boolean model = false;
        try {
        	
        	Runtime r = Runtime.getRuntime();
            long currentTime = System.currentTimeMillis();
            long initBytes = r.totalMemory() - r.freeMemory();
            
            
            model = reasoner.reason(mintermweight,mintermweight+3,reasonerTimeout);
            
            long MemoryConsumed = r.totalMemory() - r.freeMemory() - initBytes;
            long time = System.currentTimeMillis() - currentTime;
            r.gc();
            
            if (model){
            	if (!reasoner.getModel().isEmpty()){
            		Predicate matchingPredicate = null;
            			System.out.println("Model found in "+time+ "ms.\nConsumed "+MemoryConsumed+" bytes.");
            			System.out.println(reasoner.getModel().toString());
            	}
            } else {
                System.out.println("Refutation found in "+time+ "ms.\nConsumed "+MemoryConsumed+" bytes.\n");
                refuted++;
            }
        } catch (ProofNotFoundException ex){
            unsolved_timeout++;
            System.out.println("No Solution found for KRSS problem (Timeout)\n");
        } catch (Error err){
            unsolved_memory++;
            System.out.println("No Solution found for KRSS problem (Out of Memory)\n");
        }
        kb.clear();
    }
    
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		makeMatch();
	}

}
